<template>
    <div id="app">
        <nav class="navbar navbar-light bg-white border-bottom box-shadow">
            <span class="navbar-brand mb-0 h1">
                Cruds
            </span>
        </nav>

        <main
            role="main"
            class="container"
        >
            <div class="mt-5">
                <div>
                    <div class="form-group row">
                        <label for="submit_name" class="col-sm-2 col-form-label">Nome</label>
                        <div class="col-sm-10">
                            <input
                                v-model="submit.name"
                                type="text"
                                class="form-control"
                                id="submit_name"
                            >
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="submit_color" class="col-sm-2 col-form-label">Cor</label>
                        <div class="col-sm-10">
                            <select
                                v-model="submit.color"
                                class="form-control"
                                id="submit_color"
                            >
                                <option
                                    v-for="(col, n) in colors"
                                    :key="n"
                                    :value="col"
                                >
                                    {{ col }}
                                </option>
                            </select>
                        </div>
                    </div>
                </div>
                <button
                    class="btn btn-primary"
                    @click="create(submit)"
                >
                    Add
                </button>
                <button
                    class="btn btn-secondary"
                    @click="create()"
                >
                    Add Fake
                </button>
            </div>
            <div class="my-3">
                <crud-component
                    v-for="(crud, n) in cruds"
                    :key="`linha-${n}`"
                    v-bind="crud"
                    @update="update"
                    @delete="del"
                    @colors="colors = $event"
                />
            </div>
        </main>
    </div>
</template>

<script>
    // Components
    import CrudComponent from './components/Crud.vue';

    export default {
        components: {
            CrudComponent,
        },

        data: () => ({
            cruds: [],
            colors: [],
            submit: {
                name: '',
                color: '',
            },
        }),

        methods: {
            async read() {
                try {
                    const { data } = await axios.get('/api/cruds');

                    // Get Data
                    this.cruds = data;
                } catch (e) {
                    console.error(e);
                }
            },
            async create(res) {
                try {
                    let val;
                    if (res) {
                        // Create Data
                        const { data } = await axios.post('/api/cruds', {
                            ...res,
                        });

                        this.submit = {
                            name: '',
                            color: '',
                        };

                        val = data;
                    } else {
                        // Create fake Data
                        const { data } = await axios.get('/api/cruds/create');
                        val = data;
                    }
                    // Insert Object[]
                    this.cruds.push(val);
                } catch (e) {
                    console.error(e);
                }
            },
            async update(id, res) {
                try {
                    const { data } = await axios.put(`/api/cruds/${id}`, {
                        ...res,
                    });

                    // Update Object[]
                    const index = this.cruds.findIndex(crud => crud.id === id);
                    this.$set(this.cruds, index, data);
                } catch (e) {
                    console.error(e);
                }
            },
            del(id) {
                axios.delete(`/api/cruds/${id}`)
                    .then(() => {
                        // Delete Index Object[]
                        const index = this.cruds.findIndex(crud => crud.id === id);
                        this.$delete(this.cruds, index);
                    })
                    .catch(err => {
                        console.error(err);
                    });
            },
        },

        created() {
            // Init
            this.read();
        },
    };
</script>
